local hcTk = HCToolkit
local GetNumGroupMembers = GetNumGroupMembers
local NotifyInspect = NotifyInspect

function hcTk.GroupInit()
    hcTk.Group = {}
    hcTk.GroupKeys = {}
    hcTk.PlayerGUID = UnitGUID("player")
end

function hcTk.GroupFill()
    local group = hcTk.Group
    local groupKeys = hcTk.GroupKeys
    local members = GetNumGroupMembers()
    local prefix = hcTk.GroupTypeText()

    for i = 1, members do
        local unit = prefix .. i
        if (i == members and prefix == "party") then
            unit = 'player'
        end
        local guid = UnitGUID(unit)
        group[guid] = hcTk.UnitCreatePlayer(unit)
        groupKeys[i] = guid
  end
end

function hcTk.GroupUpdate()
    local newGroup = {}
    local newGroupKeys = {}
    local members = GetNumGroupMembers()
    local prefix = hcTk.GroupTypeText()

    for i = 1, members do
        unit = prefix .. i;
        if (i == members and prefix == "party") then
            unit = 'player';
        end

        local guid = UnitGUID(unit);
        if (hcTk.Group[guid] ~= nil) then
            newGroup[guid] = hcTk.Group[guid];
        else
            newGroup[guid] = hcTk.UnitCreatePlayer(unit);
        end
        newGroupKeys[i] = guid
    end

    hcTk.Group = newGroup
    hcTk.GroupKeys = newGroupKeys
end

function hcTk.GroupTypeText()
    if IsInRaid() then
        return "raid"
    else
        return "party"
    end
end